From d8ff4ec281f97310ac40644cff488b5a7062c256 Mon Sep 17 00:00:00 2001
From: Braden Obrzut <admin@maniacsvault.net>
Date: Sun, 5 Jan 2014 19:50:09 -0500
Subject: [PATCH] =?UTF-8?q?-=20Fixed:=20All=20clang=205.0=20warnings.=20-?=
 =?UTF-8?q?=20Renamed=20autostart/autozend=20since=20Xcode=E2=80=99s=20bui?=
 =?UTF-8?q?ld=20process=20links=20in=20strictly=20alphabetical=20order.?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 jpeg-6b/CMakeLists.txt                      |   2 +-
 src/CMakeLists.txt                          |   8 +--
 src/__autostart.cpp                         | 101 ++++++++++++++++++++++++++++
 src/autostart.cpp                           | 101 ----------------------------
 src/autozend.cpp                            |  73 --------------------
 src/c_console.cpp                           |   2 -
 src/files.cpp                               |   4 +-
 src/fragglescript/t_fspic.cpp               |   1 +
 src/g_shared/sbarinfo.cpp                   |   2 +
 src/menu/joystickmenu.cpp                   |  12 ++--
 src/menu/menu.h                             |   1 -
 src/menu/optionmenu.cpp                     |   5 --
 src/menu/optionmenuitems.h                  |  22 +++---
 src/nodebuild.cpp                           |   4 --
 src/oplsynth/music_opldumper_mididevice.cpp |   2 +-
 src/oplsynth/muslib.h                       |   2 +-
 src/oplsynth/opl.h                          |   1 -
 src/p_acs.cpp                               |   6 +-
 src/p_interaction.cpp                       |   2 -
 src/p_sectors.cpp                           |   2 -
 src/r_main.cpp                              |   4 --
 src/r_plane.cpp                             |   2 +-
 src/sdl/crashcatcher.c                      |   2 +-
 src/sdl/i_system.cpp                        |   2 +-
 src/sdl/iwadpicker_cocoa.mm                 |  27 ++++----
 src/sound/i_musicinterns.h                  |   2 +-
 src/sound/music_mus_opl.cpp                 |   2 +-
 src/v_video.cpp                             |   2 +-
 src/v_video.h                               |   5 +-
 src/win32/fb_d3d9.cpp                       |   5 --
 src/win32/fb_ddraw.cpp                      |   5 --
 src/win32/win32iface.h                      |   2 -
 src/zzautozend.cpp                          |  73 ++++++++++++++++++++
 33 files changed, 231 insertions(+), 255 deletions(-)
 create mode 100644 src/__autostart.cpp
 delete mode 100644 src/autostart.cpp
 delete mode 100644 src/autozend.cpp
 create mode 100644 src/zzautozend.cpp

diff --git a/jpeg-6b/CMakeLists.txt b/jpeg-6b/CMakeLists.txt
index 2109646..dd5055f 100644
--- a/jpeg-6b/CMakeLists.txt
+++ b/jpeg-6b/CMakeLists.txt
@@ -3,7 +3,7 @@ cmake_minimum_required( VERSION 2.4 )
 make_release_only()
 
 if( "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" )
-	set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -fomit-frame-pointer" )
+	set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -fomit-frame-pointer" )
 endif( "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" )
 
 add_library( jpeg
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index 2bf5a5a..4f27c70 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -412,7 +412,7 @@ if( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_CXX_COMPILER_ID}" STRE
 	set( CMAKE_CXX_FLAGS_MINSIZEREL "${REL_CXX_FLAGS} ${CMAKE_CXX_FLAGS_MINSIZEREL}" )
 	set( CMAKE_CXX_FLAGS_RELWITHDEBINFO "${REL_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}" )
 
-	set( CMAKE_CXX_FLAGS "-Wall -Wno-unused -Wextra -Wno-missing-field-initializers ${CMAKE_CXX_FLAGS}" )
+	set( CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unused -Wno-unused-parameter -Wno-missing-field-initializers ${CMAKE_CXX_FLAGS}" )
 
 	# Remove extra warnings when using the official DirectX headers.
 	# Also, TDM-GCC 4.4.0 no longer accepts glibc-style printf formats as valid,
@@ -748,7 +748,7 @@ set( NOT_COMPILED_SOURCE_FILES
 add_executable( zdoom WIN32
 	${HEADER_FILES}
 	${NOT_COMPILED_SOURCE_FILES}
-	autostart.cpp
+	__autostart.cpp
 	${ASM_SOURCES}
 	${SYSTEM_SOURCES}
 	${X86_SOURCES}
@@ -1052,7 +1052,7 @@ add_executable( zdoom WIN32
 	r_data/renderstyle.cpp
 	r_data/r_interpolate.cpp
 	r_data/r_translate.cpp
-	autozend.cpp
+	zzautozend.cpp
 )
 
 set_source_files_properties( xlat/parse_xlat.cpp PROPERTIES OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/xlat_parser.c" )
@@ -1160,7 +1160,7 @@ source_group("Render Data\\Textures" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE
 source_group("Render Interface" FILES r_defs.h r_renderer.h r_sky.cpp r_sky.h r_state.h r_utility.cpp r_utility.h)
 source_group("Resource Files" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/resourcefiles/.+")
 source_group("SDL Files" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/sdl/.+")
-source_group("SFML" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/sfmt/.+")
+source_group("SFMT" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/sfmt/.+")
 source_group("Shared Game" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/g_shared/.+")
 source_group("Versioning" FILES version.h win32/zdoom.rc)
 source_group("Win32 Files" REGULAR_EXPRESSION "^${CMAKE_CURRENT_SOURCE_DIR}/win32/.+")
diff --git a/src/__autostart.cpp b/src/__autostart.cpp
new file mode 100644
index 0000000..6ed85ae
--- /dev/null
+++ b/src/__autostart.cpp
@@ -0,0 +1,101 @@
+/*
+** autostart.cpp
+** This file contains the heads of lists stored in special data segments
+**
+**---------------------------------------------------------------------------
+** Copyright 1998-2006 Randy Heit
+** All rights reserved.
+**
+** Redistribution and use in source and binary forms, with or without
+** modification, are permitted provided that the following conditions
+** are met:
+**
+** 1. Redistributions of source code must retain the above copyright
+**    notice, this list of conditions and the following disclaimer.
+** 2. Redistributions in binary form must reproduce the above copyright
+**    notice, this list of conditions and the following disclaimer in the
+**    documentation and/or other materials provided with the distribution.
+** 3. The name of the author may not be used to endorse or promote products
+**    derived from this software without specific prior written permission.
+**
+** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+** NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+** THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+**---------------------------------------------------------------------------
+**
+** The particular scheme used here was chosen because it's small.
+**
+** An alternative that will work with any C++ compiler is to use static
+** classes to build these lists at run time. Under Visual C++, doing things
+** that way can require a lot of extra space, which is why I'm doing things
+** this way.
+**
+** In the case of PClass lists (section creg), I orginally used the
+** constructor to do just that, and the code for that still exists if you
+** compile with something other than Visual C++ or GCC.
+*/
+
+#include "autosegs.h"
+
+#if defined(_MSC_VER)
+
+#pragma comment(linker, "/merge:.areg=.data /merge:.creg=.data /merge:.greg=.data /merge:.mreg=.data /merge:.yreg=.data")
+
+#pragma data_seg(".areg$a")
+void *ARegHead = 0;
+
+#pragma data_seg(".creg$a")
+void *CRegHead = 0;
+
+#pragma data_seg(".greg$a")
+void *GRegHead = 0;
+
+#pragma data_seg(".mreg$a")
+void *MRegHead = 0;
+
+#pragma data_seg(".yreg$a")
+void *YRegHead = 0;
+
+#pragma data_seg()
+
+// We want visual styles support under XP
+#if defined _M_IX86
+
+#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
+
+#elif defined _M_IA64
+
+#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
+
+#elif defined _M_X64
+
+#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
+
+#else
+
+#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
+
+#endif
+
+#elif defined(__GNUC__)
+
+#include "doomtype.h"
+
+void *ARegHead __attribute__((section(SECTION_AREG))) = 0;
+void *CRegHead __attribute__((section(SECTION_CREG))) = 0;
+void *GRegHead __attribute__((section(SECTION_GREG))) = 0;
+void *MRegHead __attribute__((section(SECTION_MREG))) = 0;
+void *YRegHead __attribute__((section(SECTION_YREG))) = 0;
+
+#else
+
+#error Please fix autostart.cpp for your compiler
+
+#endif
diff --git a/src/c_console.cpp b/src/c_console.cpp
index 0c02d04..c25a460 100644
--- a/src/c_console.cpp
+++ b/src/c_console.cpp
@@ -610,8 +610,6 @@ static int FlushLines (const char *start, const char *stop)
 			break;
 		}
 	}
-	if (i != TopLine)
-		i = i;
 	return i;
 }
 
diff --git a/src/files.cpp b/src/files.cpp
index 80f0f83..d7dfc2c 100644
--- a/src/files.cpp
+++ b/src/files.cpp
@@ -370,8 +370,8 @@ extern "C" void bz_internal_error (int errcode)
 //
 //==========================================================================
 
-static void *SzAlloc(void *p, size_t size) { p = p; return malloc(size); }
-static void SzFree(void *p, void *address) { p = p; free(address); }
+static void *SzAlloc(void *, size_t size) { return malloc(size); }
+static void SzFree(void *, void *address) { free(address); }
 ISzAlloc g_Alloc = { SzAlloc, SzFree };
 
 FileReaderLZMA::FileReaderLZMA (FileReader &file, size_t uncompressed_size, bool zip)
diff --git a/src/fragglescript/t_fspic.cpp b/src/fragglescript/t_fspic.cpp
index d5e6e5a..9da3cf1 100644
--- a/src/fragglescript/t_fspic.cpp
+++ b/src/fragglescript/t_fspic.cpp
@@ -73,6 +73,7 @@ public:
 	~DHUDPicManager() {}
 	void Serialize(FArchive & ar);
 	virtual void DoDraw (int linenum, int x, int y, int hudheight, float translucent);
+	void DoDraw (int, int, int, bool, int) { assert(false); }
 } ;
 
 IMPLEMENT_CLASS(DHUDPicManager)
diff --git a/src/g_shared/sbarinfo.cpp b/src/g_shared/sbarinfo.cpp
index 3e1c364..a738a5a 100644
--- a/src/g_shared/sbarinfo.cpp
+++ b/src/g_shared/sbarinfo.cpp
@@ -303,6 +303,8 @@ class SBarInfoMainBlock : public SBarInfoCommandFlowControl
 		int		Alpha() const { return currentAlpha; }
 		// Same as Draw but takes into account ForceScaled and temporarily sets the scaling if needed.
 		void	DrawAux(const SBarInfoMainBlock *block, DSBarInfo *statusBar, int xOffset, int yOffset, int alpha);
+		// Silence hidden overload warning since this is a special use class.
+		using SBarInfoCommandFlowControl::Draw;
 		void	Draw(const SBarInfoMainBlock *block, const DSBarInfo *statusBar, int xOffset, int yOffset, int alpha)
 		{
 			this->xOffset = xOffset;
diff --git a/src/menu/joystickmenu.cpp b/src/menu/joystickmenu.cpp
index 6be7288..a7d950e 100644
--- a/src/menu/joystickmenu.cpp
+++ b/src/menu/joystickmenu.cpp
@@ -74,12 +74,12 @@ public:
 	{
 	}
 
-	double GetValue()
+	double GetSliderValue()
 	{
 		return SELECTED_JOYSTICK->GetSensitivity();
 	}
 
-	void SetValue(double val)
+	void SetSliderValue(double val)
 	{
 		SELECTED_JOYSTICK->SetSensitivity(float(val));
 	}
@@ -104,14 +104,14 @@ public:
 		mNeg = 1;
 	}
 
-	double GetValue()
+	double GetSliderValue()
 	{
 		double d = SELECTED_JOYSTICK->GetAxisScale(mAxis);
 		mNeg = d < 0? -1:1;
 		return d;
 	}
 
-	void SetValue(double val)
+	void SetSliderValue(double val)
 	{
 		SELECTED_JOYSTICK->SetAxisScale(mAxis, float(val * mNeg));
 	}
@@ -136,14 +136,14 @@ public:
 		mNeg = 1;
 	}
 
-	double GetValue()
+	double GetSliderValue()
 	{
 		double d = SELECTED_JOYSTICK->GetAxisDeadZone(mAxis);
 		mNeg = d < 0? -1:1;
 		return d;
 	}
 
-	void SetValue(double val)
+	void SetSliderValue(double val)
 	{
 		SELECTED_JOYSTICK->SetAxisDeadZone(mAxis, float(val * mNeg));
 	}
diff --git a/src/menu/menu.h b/src/menu/menu.h
index 1388a33..3712c90 100644
--- a/src/menu/menu.h
+++ b/src/menu/menu.h
@@ -553,7 +553,6 @@ public:
 	}
 
 	~FOptionMenuItem();
-	virtual bool CheckCoordinate(FOptionMenuDescriptor *desc, int x, int y);
 	virtual int Draw(FOptionMenuDescriptor *desc, int y, int indent, bool selected);
 	virtual bool Selectable();
 	virtual int GetIndent();
diff --git a/src/menu/optionmenu.cpp b/src/menu/optionmenu.cpp
index 08489fe..eff53fc 100644
--- a/src/menu/optionmenu.cpp
+++ b/src/menu/optionmenu.cpp
@@ -468,11 +468,6 @@ FOptionMenuItem::~FOptionMenuItem()
 	if (mLabel != NULL) delete [] mLabel;
 }
 
-bool FOptionMenuItem::CheckCoordinate(FOptionMenuDescriptor *desc, int x, int y)
-{
-	return false;
-}
-
 int FOptionMenuItem::Draw(FOptionMenuDescriptor *desc, int y, int indent, bool selected)
 {
 	return indent;
diff --git a/src/menu/optionmenuitems.h b/src/menu/optionmenuitems.h
index ff3eb01..439ed7f 100644
--- a/src/menu/optionmenuitems.h
+++ b/src/menu/optionmenuitems.h
@@ -560,8 +560,8 @@ public:
 		mSliderShort = 0;
 	}
 
-	virtual double GetValue() = 0;
-	virtual void SetValue(double val) = 0;
+	virtual double GetSliderValue() = 0;
+	virtual void SetSliderValue(double val) = 0;
 
 	//=============================================================================
 	//
@@ -614,14 +614,14 @@ public:
 	{
 		drawLabel(indent, y, selected? OptionSettings.mFontColorSelection : OptionSettings.mFontColor);
 		mDrawX = indent + CURSORSPACE;
-		DrawSlider (mDrawX, y, mMin, mMax, GetValue(), mShowValue, indent);
+		DrawSlider (mDrawX, y, mMin, mMax, GetSliderValue(), mShowValue, indent);
 		return indent;
 	}
 
 	//=============================================================================
 	bool MenuEvent (int mkey, bool fromcontroller)
 	{
-		double value = GetValue();
+		double value = GetSliderValue();
 
 		if (mkey == MKEY_Left)
 		{
@@ -635,7 +635,7 @@ public:
 		{
 			return FOptionMenuItem::MenuEvent(mkey, fromcontroller);
 		}
-		SetValue(clamp(value, mMin, mMax));
+		SetSliderValue(clamp(value, mMin, mMax));
 		S_Sound (CHAN_VOICE | CHAN_UI, "menu/change", snd_menuvolume, ATTN_NONE);
 		return true;
 	}
@@ -662,9 +662,9 @@ public:
 
 		x = clamp(x, slide_left, slide_right);
 		double v = mMin + ((x - slide_left) * (mMax - mMin)) / (slide_right - slide_left);
-		if (v != GetValue())
+		if (v != GetSliderValue())
 		{
-			SetValue(v);
+			SetSliderValue(v);
 			//S_Sound (CHAN_VOICE | CHAN_UI, "menu/change", snd_menuvolume, ATTN_NONE);
 		}
 		if (type == DMenu::MOUSE_Click)
@@ -692,7 +692,7 @@ public:
 		mCVar = FindCVar(menu, NULL);
 	}
 
-	double GetValue()
+	double GetSliderValue()
 	{
 		if (mCVar != NULL)
 		{
@@ -704,7 +704,7 @@ public:
 		}
 	}
 
-	void SetValue(double val)
+	void SetSliderValue(double val)
 	{
 		if (mCVar != NULL)
 		{
@@ -732,12 +732,12 @@ public:
 		mPVal = pVal;
 	}
 
-	double GetValue()
+	double GetSliderValue()
 	{
 		return *mPVal;
 	}
 
-	void SetValue(double val)
+	void SetSliderValue(double val)
 	{
 		*mPVal = (float)val;
 	}
diff --git a/src/nodebuild.cpp b/src/nodebuild.cpp
index c13527d..be5d059 100644
--- a/src/nodebuild.cpp
+++ b/src/nodebuild.cpp
@@ -504,10 +504,6 @@ int FNodeBuilder::SelectSplitter (DWORD set, node_t &node, DWORD &splitseg, int
 					nosplitters = true;
 				}
 			}
-			else
-			{
-				pseg = pseg;
-			}
 		}
 
 		seg = pseg->next;
diff --git a/src/oplsynth/music_opldumper_mididevice.cpp b/src/oplsynth/music_opldumper_mididevice.cpp
index 0bb9ac1..74bef06 100644
--- a/src/oplsynth/music_opldumper_mididevice.cpp
+++ b/src/oplsynth/music_opldumper_mididevice.cpp
@@ -139,7 +139,7 @@ DiskWriterIO::~DiskWriterIO()
 //
 //==========================================================================
 
-int DiskWriterIO::OPLinit(uint numchips, bool dontcare)
+int DiskWriterIO::OPLinit(uint numchips, bool, bool)
 {
 	// If the file extension is unknown or not present, the default format
 	// is RAW. Otherwise, you can use DRO.
diff --git a/src/oplsynth/muslib.h b/src/oplsynth/muslib.h
index 404ce1e..6cfb5bd 100644
--- a/src/oplsynth/muslib.h
+++ b/src/oplsynth/muslib.h
@@ -195,7 +195,7 @@ struct DiskWriterIO : public OPLio
 	DiskWriterIO(const char *filename);
 	~DiskWriterIO();
 
-	int OPLinit(uint numchips, bool notused=false);
+	int OPLinit(uint numchips, bool notused=false, bool notused2=false);
 	void OPLdeinit();
 	void OPLwriteReg(int which, uint reg, uchar data);
 	void SetClockRate(double samples_per_tick);
diff --git a/src/oplsynth/opl.h b/src/oplsynth/opl.h
index eb46c99..661258a 100644
--- a/src/oplsynth/opl.h
+++ b/src/oplsynth/opl.h
@@ -15,7 +15,6 @@ public:
 	virtual void WriteReg(int reg, int v) = 0;
 	virtual void Update(float *buffer, int length) = 0;
 	virtual void SetPanning(int c, float left, float right) = 0;
-	virtual FString GetVoiceString() { return FString(); }
 };
 
 OPLEmul *YM3812Create(bool stereo);
diff --git a/src/p_acs.cpp b/src/p_acs.cpp
index fa9e6d9..fd168f9 100644
--- a/src/p_acs.cpp
+++ b/src/p_acs.cpp
@@ -6807,12 +6807,16 @@ scriptwait:
 			break;
 
 		case PCD_PRINTBINARY:
-#if defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && (__GNUC_MINOR__ >= 6)))
+#if (defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && (__GNUC_MINOR__ >= 6)))) || defined(__clang__)
 #define HAS_DIAGNOSTIC_PRAGMA
 #endif
 #ifdef HAS_DIAGNOSTIC_PRAGMA
 #pragma GCC diagnostic push
+#ifdef __clang__
+#pragma GCC diagnostic ignored "-Wformat-invalid-specifier"
+#else
 #pragma GCC diagnostic ignored "-Wformat="
+#endif
 #pragma GCC diagnostic ignored "-Wformat-extra-args"
 #endif
 			work.AppendFormat ("%B", STACK(1));
diff --git a/src/p_interaction.cpp b/src/p_interaction.cpp
index 47ed878..4be8ed6 100644
--- a/src/p_interaction.cpp
+++ b/src/p_interaction.cpp
@@ -364,8 +364,6 @@ void AActor::Die (AActor *source, AActor *inflictor, int dmgflags)
 	{
 		static int dieticks[MAXPLAYERS];
 		int pnum = int(this->player-players);
-		if (dieticks[pnum] == gametic)
-			gametic=gametic;
 		dieticks[pnum] = gametic;
 		fprintf (debugfile, "died (%d) on tic %d (%s)\n", pnum, gametic,
 		this->player->cheats&CF_PREDICTING?"predicting":"real");
diff --git a/src/p_sectors.cpp b/src/p_sectors.cpp
index d90466f..6993508 100644
--- a/src/p_sectors.cpp
+++ b/src/p_sectors.cpp
@@ -230,8 +230,6 @@ fixed_t sector_t::FindNextLowestFloor (vertex_t **v) const
 		check = lines[i];
 		if (NULL != (other = getNextSector (check, this)))
 		{
-			if (other - sectors == 6)
-				other = other;
 			ofloor = other->floorplane.ZatPoint (check->v1);
 			floor = floorplane.ZatPoint (check->v1);
 			if (ofloor < floor && floor - ofloor < heightdiff && !IsLinked(other, false))
diff --git a/src/r_main.cpp b/src/r_main.cpp
index edb13d3..a726bc7 100644
--- a/src/r_main.cpp
+++ b/src/r_main.cpp
@@ -706,10 +706,6 @@ void R_EnterMirror (drawseg_t *ds, int depth)
 			R_EnterMirror (drawsegs + WallMirrors[mirrorsAtStart], depth + 1);
 		}
 	}
-	else
-	{
-		depth = depth;
-	}
 
 	viewangle = startang;
 	viewx = startx;
diff --git a/src/r_plane.cpp b/src/r_plane.cpp
index 986d992..07bbbbe 100644
--- a/src/r_plane.cpp
+++ b/src/r_plane.cpp
@@ -560,7 +560,7 @@ static visplane_t *new_visplane (unsigned hash)
 	{
 		check = (visplane_t *)M_Malloc (sizeof(*check) + sizeof(*check->top)*(MAXWIDTH*2));
 		memset(check, 0, sizeof(*check) + sizeof(*check->top)*(MAXWIDTH*2));
-		check->bottom = &check->top[MAXWIDTH+2];
+		check->bottom = check->top + MAXWIDTH+2;
 	}
 	else if (NULL == (freetail = freetail->next))
 	{
diff --git a/src/sdl/crashcatcher.c b/src/sdl/crashcatcher.c
index 37511f6..a4f68d9 100644
--- a/src/sdl/crashcatcher.c
+++ b/src/sdl/crashcatcher.c
@@ -192,7 +192,7 @@ static size_t safe_write(int fd, const void *buf, size_t len)
 
 static void crash_catcher(int signum, siginfo_t *siginfo, void *context)
 {
-	ucontext_t *ucontext = (ucontext_t*)context;
+	//ucontext_t *ucontext = (ucontext_t*)context;
 	pid_t dbg_pid;
 	int fd[2];
 
diff --git a/src/sdl/i_system.cpp b/src/sdl/i_system.cpp
index 03cbd74..6bd95d6 100644
--- a/src/sdl/i_system.cpp
+++ b/src/sdl/i_system.cpp
@@ -719,7 +719,7 @@ bool I_WriteIniFailed ()
 
 static const char *pattern;
 
-#if defined(__APPLE__) && !defined(__llvm__)
+#if defined(__APPLE__) && !defined(__MAC_10_8)
 static int matchfile (struct dirent *ent)
 #else
 static int matchfile (const struct dirent *ent)
diff --git a/src/sdl/iwadpicker_cocoa.mm b/src/sdl/iwadpicker_cocoa.mm
index a0469ac..06f8409 100644
--- a/src/sdl/iwadpicker_cocoa.mm
+++ b/src/sdl/iwadpicker_cocoa.mm
@@ -48,13 +48,16 @@ enum
 static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 
 // Class to convert the IWAD data into a form that Cocoa can use.
-@interface IWADTableData : NSObject// <NSTableViewDataSource>
+@interface IWADTableData : NSObject
+#ifdef __MAC_10_6
+	<NSTableViewDataSource>
+#endif
 {
 	NSMutableArray *data;
 }
 
 - (void)dealloc;
-- (IWADTableData *)init:(WadStuff *) wads:(int) numwads;
+- (IWADTableData *)init:(WadStuff *) wads num:(int) numwads;
 
 - (int)numberOfRowsInTableView:(NSTableView *)aTableView;
 - (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
@@ -69,7 +72,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 	[super dealloc];
 }
 
-- (IWADTableData *)init:(WadStuff *) wads:(int) numwads
+- (IWADTableData *)init:(WadStuff *) wads num:(int) numwads
 {
 	data = [[NSMutableArray alloc] initWithCapacity:numwads];
 
@@ -116,13 +119,13 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 
 - (void)buttonPressed:(id) sender;
 - (void)doubleClicked:(id) sender;
-- (void)makeLabel:(NSTextField *)label:(const char*) str;
-- (int)pickIWad:(WadStuff *)wads:(int) numwads:(bool) showwin:(int) defaultiwad;
+- (void)makeLabel:(NSTextField *)label withString:(const char*) str;
+- (int)pickIWad:(WadStuff *)wads num:(int) numwads showWindow:(bool) showwin defaultWad:(int) defaultiwad;
 @end
 
 @implementation IWADPicker
 
-- (void)buttonPressed:(id) sender;
+- (void)buttonPressed:(id) sender
 {
 	if(sender == cancelButton)
 		cancelled = true;
@@ -131,7 +134,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 	[app stopModal];
 }
 
-- (void)doubleClicked:(id) sender;
+- (void)doubleClicked:(id) sender
 {
 	if ([sender clickedRow] >= 0)
 	{
@@ -142,7 +145,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 
 // Apparently labels in Cocoa are uneditable text fields, so lets make this a
 // little more automated.
-- (void)makeLabel:(NSTextField *)label:(const char*) str
+- (void)makeLabel:(NSTextField *)label withString:(const char*) str
 {
 	[label setStringValue:[NSString stringWithUTF8String:str]];
 	[label setBezeled:NO];
@@ -151,7 +154,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 	[label setSelectable:NO];
 }
 
-- (int)pickIWad:(WadStuff *)wads:(int) numwads:(bool) showwin:(int) defaultiwad
+- (int)pickIWad:(WadStuff *)wads num:(int) numwads showWindow:(bool) showwin defaultWad:(int) defaultiwad
 {
 	cancelled = false;
 
@@ -163,7 +166,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 	[window setTitle:windowTitle];
 
 	NSTextField *description = [[NSTextField alloc] initWithFrame:NSMakeRect(22, 379, 412, 50)];
-	[self makeLabel:description:"ZDoom found more than one IWAD\nSelect from the list below to determine which one to use:"];
+	[self makeLabel:description withString:"ZDoom found more than one IWAD\nSelect from the list below to determine which one to use:"];
 	[[window contentView] addSubview:description];
 	[description release];
 
@@ -171,7 +174,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 	//NSScrollView *iwadScroller = [[NSScrollView alloc] initWithFrame:NSMakeRect(20, 103, 412, 288)];
 	NSScrollView *iwadScroller = [[NSScrollView alloc] initWithFrame:NSMakeRect(20, 50, 412, 341)];
 	NSTableView *iwadTable = [[NSTableView alloc] initWithFrame:[iwadScroller bounds]];
-	IWADTableData *tableData = [[IWADTableData alloc] init:wads:numwads];
+	IWADTableData *tableData = [[IWADTableData alloc] init:wads num:numwads];
 	for(int i = 0;i < NUM_COLUMNS;i++)
 	{
 		NSTableColumn *column = [[NSTableColumn alloc] initWithIdentifier:[NSString stringWithUTF8String:tableHeaders[i]]];
@@ -242,7 +245,7 @@ static const char* const tableHeaders[NUM_COLUMNS] = { "IWAD", "Game" };
 int I_PickIWad_Cocoa (WadStuff *wads, int numwads, bool showwin, int defaultiwad)
 {
 	IWADPicker *picker = [IWADPicker alloc];
-	int ret = [picker pickIWad:wads:numwads:showwin:defaultiwad];
+	int ret = [picker pickIWad:wads num:numwads showWindow:showwin defaultWad:defaultiwad];
 	[picker release];
 	return ret;
 }
diff --git a/src/sound/i_musicinterns.h b/src/sound/i_musicinterns.h
index 3c1134c..fa04cfa 100644
--- a/src/sound/i_musicinterns.h
+++ b/src/sound/i_musicinterns.h
@@ -709,7 +709,7 @@ class OPLMUSDumper : public OPLMUSSong
 {
 public:
 	OPLMUSDumper(const OPLMUSSong *original, const char *filename);
-	void Play(bool looping);
+	void Play(bool looping, int);
 };
 
 // CD track/disk played through the multimedia system -----------------------
diff --git a/src/sound/music_mus_opl.cpp b/src/sound/music_mus_opl.cpp
index 156094e..fb0d78d 100644
--- a/src/sound/music_mus_opl.cpp
+++ b/src/sound/music_mus_opl.cpp
@@ -100,7 +100,7 @@ OPLMUSDumper::OPLMUSDumper(const OPLMUSSong *original, const char *filename)
 {
 }
 
-void OPLMUSDumper::Play(bool looping)
+void OPLMUSDumper::Play(bool looping, int)
 {
 	Music->Dump();
 }
diff --git a/src/v_video.cpp b/src/v_video.cpp
index 855b9fd..fa94cd4 100644
--- a/src/v_video.cpp
+++ b/src/v_video.cpp
@@ -795,7 +795,7 @@ bool DSimpleCanvas::IsValid ()
 //
 //==========================================================================
 
-bool DSimpleCanvas::Lock ()
+bool DSimpleCanvas::Lock (bool)
 {
 	if (LockCount == 0)
 	{
diff --git a/src/v_video.h b/src/v_video.h
index 09022d9..b0885f3 100644
--- a/src/v_video.h
+++ b/src/v_video.h
@@ -157,8 +157,7 @@ public:
 	virtual bool IsValid ();
 
 	// Access control
-	virtual bool Lock () = 0;		// Returns true if the surface was lost since last time
-	virtual bool Lock (bool usesimplecanvas) { return Lock(); }	
+	virtual bool Lock (bool buffered=true) = 0;		// Returns true if the surface was lost since last time
 	virtual void Unlock () = 0;
 	virtual bool IsLocked () { return Buffer != NULL; }	// Returns true if the surface is locked
 
@@ -287,7 +286,7 @@ public:
 	~DSimpleCanvas ();
 
 	bool IsValid ();
-	bool Lock ();
+	bool Lock (bool buffered=true);
 	void Unlock ();
 
 protected:
diff --git a/src/win32/fb_d3d9.cpp b/src/win32/fb_d3d9.cpp
index 6481042..ac8102c 100644
--- a/src/win32/fb_d3d9.cpp
+++ b/src/win32/fb_d3d9.cpp
@@ -1033,11 +1033,6 @@ bool D3DFB::IsFullscreen ()
 //
 //==========================================================================
 
-bool D3DFB::Lock ()
-{
-	return Lock(true);
-}
-
 bool D3DFB::Lock (bool buffered)
 {
 	if (LockCount++ > 0)
diff --git a/src/win32/fb_ddraw.cpp b/src/win32/fb_ddraw.cpp
index 9fb65c2..71d37d5 100644
--- a/src/win32/fb_ddraw.cpp
+++ b/src/win32/fb_ddraw.cpp
@@ -815,11 +815,6 @@ HRESULT DDrawFB::GetHR ()
 	return LastHR;
 }
 
-bool DDrawFB::Lock ()
-{
-	return Lock (false);
-}
-
 bool DDrawFB::Lock (bool useSimpleCanvas)
 {
 	static int lock_num;
diff --git a/src/win32/win32iface.h b/src/win32/win32iface.h
index 07151fb..2704de0 100644
--- a/src/win32/win32iface.h
+++ b/src/win32/win32iface.h
@@ -148,7 +148,6 @@ public:
 	~DDrawFB ();
 
 	bool IsValid ();
-	bool Lock ();
 	bool Lock (bool buffer);
 	void Unlock ();
 	void ForceBuffering (bool force);
@@ -231,7 +230,6 @@ public:
 	~D3DFB ();
 
 	bool IsValid ();
-	bool Lock ();
 	bool Lock (bool buffered);
 	void Unlock ();
 	void Update ();
diff --git a/src/zzautozend.cpp b/src/zzautozend.cpp
new file mode 100644
index 0000000..023f8c7
--- /dev/null
+++ b/src/zzautozend.cpp
@@ -0,0 +1,73 @@
+/*
+** autozend.cpp
+** This file contains the tails of lists stored in special data segments
+**
+**---------------------------------------------------------------------------
+** Copyright 1998-2006 Randy Heit
+** All rights reserved.
+**
+** Redistribution and use in source and binary forms, with or without
+** modification, are permitted provided that the following conditions
+** are met:
+**
+** 1. Redistributions of source code must retain the above copyright
+**    notice, this list of conditions and the following disclaimer.
+** 2. Redistributions in binary form must reproduce the above copyright
+**    notice, this list of conditions and the following disclaimer in the
+**    documentation and/or other materials provided with the distribution.
+** 3. The name of the author may not be used to endorse or promote products
+**    derived from this software without specific prior written permission.
+**
+** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+** INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+** NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+** THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+**---------------------------------------------------------------------------
+**
+** See autostart.cpp for an explanation of why I do things like this.
+*/
+
+#include "autosegs.h"
+
+#if defined(_MSC_VER)
+
+#pragma data_seg(".areg$z")
+void *ARegTail = 0;
+
+#pragma data_seg(".creg$z")
+void *CRegTail = 0;
+
+#pragma data_seg(".greg$z")
+void *GRegTail = 0;
+
+#pragma data_seg(".mreg$z")
+void *MRegTail = 0;
+
+#pragma data_seg(".yreg$z")
+void *YRegTail = 0;
+
+#pragma data_seg()
+
+
+
+#elif defined(__GNUC__)
+
+#include "doomtype.h"
+
+void *ARegTail __attribute__((section(SECTION_AREG))) = 0;
+void *CRegTail __attribute__((section(SECTION_CREG))) = 0;
+void *GRegTail __attribute__((section(SECTION_GREG))) = 0;
+void *MRegTail __attribute__((section(SECTION_MREG))) = 0;
+void *YRegTail __attribute__((section(SECTION_YREG))) = 0;
+
+#else
+
+#error Please fix autozend.cpp for your compiler
+
+#endif
-- 
1.8.4.2

